#ifndef __MISC_H
#define __MISC_H        1

#ifdef __cplusplus
extern "C" {
#endif

typedef FormGadgetType *GadgetPtr;

CharPtr StrLToA (CharPtr lpStr, Long lNum);
Long StrAToL (CharPtr lpStr);
void QShuffle (BytePtr base, Int numOfElements, Int width);

void InitPopup (FormPtr fpForm, Word wTriggerId, Word wListId, Int iCurrent);
Int SelectPopup (FormPtr fpForm, Word wTriggerId, Word wListId, Int iCurrent);
Int ChangePopup (FormPtr fpForm, Word wTriggerId, Word wListId, Int iCurrent);

Int InitDynamicPopup (FormPtr fpForm, Word wTriggerId);
Int SetDynamicPopup (FormPtr fpForm, Word wTriggerId, CharPtr pText);
Int SelectDynamicPopup (FormPtr fpForm, Word wTriggerId, Word wListId, Int iCurrent, Char **pList, Int iSize);

VoidHand SetField (FormPtr fpForm, Word wFieldId, ULong ulMaxChars, CharPtr cpText);
void DrawCenteredChars (CharPtr chars, Word len, RectanglePtr r);
void EraseCenteredChars (CharPtr chars, Word len, RectanglePtr r);

void SetCheck (FormPtr fpForm, Word wFieldId, Boolean bCheckState);
Boolean GetCheck (FormPtr fpForm, Word wFieldId);

void SetPushButton (FormPtr fpForm, Word wStartFieldId, Word wEndFieldId, Word wFieldId);
Word GetPushButton (FormPtr fpForm, Word wStartFieldId, Word wEndFieldId);

void ReadRecord (DmOpenRef hDataBase, UInt uiIndex, VoidPtr pVoid, ULong ulLength);
void OverwriteRecord (DmOpenRef hDataBase, UInt uiIndex, VoidPtr pVoid, ULong ulLength);
void InsertRecord (DmOpenRef hDataBase, UInt uiIndex, VoidPtr pVoid, ULong ulLength);

#ifdef __cplusplus
}
#endif

#endif
