#include "StdInc.h"
#include "RollEmUpd.h"
#include "EditTitle.h"
#include "Sound.h"

/*
Boolean EditTitleProc (EventPtr event)
{
    FormPtr pForm;
    Int handled = 0;

	pForm = FrmGetActiveForm();
    switch (event->eType) 
    {
        case ctlSelectEvent:
		{
            switch (event->data.ctlEnter.controlID)
            {
			case IDC_OK:
				handled = 0; // If handled the dialog will not close.
				break;
			case IDC_CANCEL:
				handled = 0;
				break;
            }
            break;
		}
	}

	return handled;
}
*/
Word DoEditTitle (SoundPtr pSound)
{
	static Boolean bInit = false;
	FormPtr pForm, pOldForm;
	Word wResult;
	VoidHand hTitle;
	CharPtr pTitle;

	wResult = 0;
	pOldForm = FrmGetActiveForm();
	if (pForm = FrmInitForm(IDF_EDIT_TITLE))
	{
		// Do the one time initialization 
		//  of the Sound dialog here.
		if (!bInit)
		{
			bInit = true;
		}

		// Do the every time initialization 
		//  of the Sound dialog here.
		hTitle = SetField (pForm, IDC_TITLE_FIELD, MAX_TITLE_LEN, ((pSound) ? pSound->szTitle : ""));
		FrmSetFocus(pForm, FrmGetObjectIndex(pForm, IDC_TITLE_FIELD));

		// Show the dialog.
//		FrmSetEventHandler(pForm, (FormEventHandlerPtr) EditTitleProc);
		wResult = FrmDoDialog(pForm);

		if (wResult == IDC_OK)
		{
			pTitle = (CharPtr)MemHandleLock(hTitle);
			if (StrLen(pTitle) > 0)
			{
				if (pSound == 0)
				{
					Int iCount;

					iCount = GetSoundCount();
					AddSound(iCount, 0);
					GetSound(iCount, &pSound);
				}
				if (pSound)
					StrCopy(pSound->szTitle, pTitle);
			}
			MemHandleUnlock(hTitle);
		}

		// We now return to our other window.
		if (pOldForm)
			FrmSetActiveForm(pOldForm);
		FrmDeleteForm(pForm);
	}

	return wResult;
}
